<?php

const SECURE = false;

function getDestUrl($params) {
    if (empty($params)) {
        return '/';
    }

    $viewUrl = isset($params['VIEW_URL']) ? $params['VIEW_URL'] : '/';
    $vcUrl = isset($params['VC_URL']) ? $params['VC_URL'] : '';
    if (empty($vcUrl)) {
        return $viewUrl;
    }

    return $vcUrl;
}

function redirectLP($vcLpp, $destUrl) {
    $html = '<html><head"></head><body></body>';
    $html .= '<script>var vc_lpp = "' . rawurlencode($vcLpp) . '"; var dest_url = "' . $destUrl . '";</script>';
    $html .= '<script type="text/javascript" src="//cej.valuecommerce.com/vcce.js"></script>';
    $html .= '<script>if("function"!=typeof vcIBeacon){window.location.replace("' . $destUrl . '")}</script>';
    $html .= '</html>';
    print $html;
}

function setVCCookie($param, $now) {
    $arr = explode('&',$param);
    if (count($arr) < 5) {
        return;
    }

    if (!(ctype_xdigit($arr[2]) && ctype_xdigit($arr[3]) && ctype_xdigit($arr[4]))) {
        return;
    }

    $exp = hexdec($arr[2]) + 10800;
    if ($now > $exp) {
        return;
    }

    $cKey = '_vc_cec_' . hexdec($arr[3]);
    $cVal = '2&' . $arr[5];
    $cPath = '/';
    $cExp = hexdec($arr[4]);
    $dArr = explode('.', $_SERVER["HTTP_HOST"]);
    $dlen = count($dArr);
    if (SECURE) {
        $secure = true;
    } else {
        $secure = isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on';
        if (!$secure) {
            $secure = isset($_SERVER['HTTP_X_FORWARDED_PROTO']) && $_SERVER['HTTP_X_FORWARDED_PROTO'] == 'https';
        }
    }
    $http = true;
    for ($ix = 2; $dlen >= $ix && $ix <= 3; $ix++) {
        $cDom = '.' . implode('.', array_slice($dArr, $ix * -1));
        setcookie($cKey, $cVal, $cExp, $cPath, $cDom, $secure, $http);
    }
}

function setVCCookies($params) {
    $vcLpp = '';
    if (empty($params) && !isset($params['VC_LPP'])) {
        return $vcLpp;
    }
    $vcLpp = base64_decode(strtr($params['VC_LPP'], '-_', '+/'));

    $now = time();
    $pArr = explode(hex2bin('02'),$vcLpp);
    for ($ix = 0; $ix < count($pArr); $ix++) {
        setVCCookie($pArr[$ix], $now);
    }

    return $vcLpp;
}

function getParams() {
    $params = [];
    $qstr = filter_input(INPUT_SERVER, 'QUERY_STRING', FILTER_SANITIZE_URL);
    if (empty($qstr)) {
        return $params;
    }

    $queries = explode('&', $qstr);
    foreach ($queries as $query) {
        $keyValue = explode('=', $query, 2);
        $params[strtoupper(rawurldecode($keyValue[0]))] = rawurldecode($keyValue[1]);
    }

    return $params;	
}

$params = getParams();
$vcLpp = setVCCookies($params);
$destUrl = getDestUrl($params);
redirectLP($vcLpp, $destUrl);
exit;
?>
